using System;
using System.Collections.Generic;

namespace Takmicenje1
{
    internal class Program
    {
        static void Main()
        {
            int N, Q;
            List<long> dan = new List<long>();
            List<long> pakovanje = new List<long>();
            List<long> kraj = new List<long>();

            string[] unos = Console.ReadLine().Split();
            N = int.Parse(unos[0]);
            Q = int.Parse(unos[1]);

            for (int i = 0; i < N; i++)
            {
                string[] dpUnos = Console.ReadLine().Split();
                dan.Add(long.Parse(dpUnos[0]));
                pakovanje.Add(long.Parse(dpUnos[1]));
            }

            for (int i = 0; i < Q; i++)
            {
                kraj.Add(long.Parse(Console.ReadLine()));
            }

            dan.Sort();

            foreach (long krajnjiDan in kraj)
            {
                int indeks = -1;
                for (int i = 0; i < N; i++)
                {
                    if (dan[i] <= krajnjiDan)
                    {
                        indeks = i;
                    }
                }

                Console.WriteLine(dan[indeks]);
            }
        }
    }
}